program Sparse_weight_random
  ! Calculates D^-.5(D-W)D^.5 for a sparse matrix out of core   Jesse Lomask 9/22/04

  use sep
  use lint2
  use warp_mod
  use sorting_mod
  use paint_mod

  implicit none

  integer				::nt, nx, ny, non_zero_mask
  integer				::it,ix,ir,iq,iz,max_dist,dense_dist
  integer                               ::irow,row1,col1,row2,col2,val_cnt,n_new_val,rand_jump_int
  integer                               ::box_size,big_box_size,fill
  integer                               ::row2_raw,col2_raw,delta_row2,delta_col2
  integer                               ::row1_grid,col1_grid,row2_grid,col2_grid
  integer                               ::irow_mat,icol_mat,sample_num,nodes
  integer                               ::drow,row1_back,col1_back,row2_back,col2_back
  integer                               ::sparse_mat_index,col_in_row,sparse_index
  integer                               ::box_x,box_t,stat1,dcol,index_new
  integer                               ::total_sparse,row_count,last_index,smpl_cnt
  integer                               ::newsize,ncv_val,mem_alloc,sample_scale
  integer                               ::ignore_wrapping
  integer,allocatable, dimension(:,:)               ::sample_template,sample_template2
  real                                  ::maxdat,mindat,rangedat,amp_thresh,zero_tol
  real                                  ::rand_jump,dist,iz_rl, wt,pi_var
  real                                  ::row1_grid_rl,col1_grid_rl,row2_grid_rl,col2_grid_rl
  real                                  ::subsam_increment
  real,dimension(:),allocatable		::dd
  real,dimension(:),allocatable		::topbnd,botbnd
  real,dimension(:),allocatable	        ::val_list,box_grid_1d,d_vec,d_vec_exp
  real, pointer, dimension(:,:)	        ::d, norm_d, mask_in,sparse_mat,xy
  real, pointer, dimension(:,:)	        ::DminusW,DminusWD,DDminusWD
  real, dimension(:,:),allocatable      ::box_grid,box_grid_col,box_grid_row
  real, dimension(:,:),allocatable      ::look_up_tab
  real, dimension(:,:),allocatable      ::sparse_mat_sort
  real, dimension(:,:),allocatable      ::box_grid_bnds
  real, dimension(:,:),allocatable      ::sparse_mat2,tester

  ! HOOK UP SEP PARAMETER INPUT FACILITY
  call sep_init(SOURCE)

  ! INPUT PARAMETERS
  call from_history("n1",nt); call from_history("n2",nx);
  call from_history("n3",ny);
  call from_param("max_dist",max_dist,21)
  call from_param("dense_dist",dense_dist,20)
  call from_param("amp_thresh",amp_thresh,.93)
  call from_param("zero_tol",zero_tol,.0001)
  call from_param("ncv_val",ncv_val,20)
  call from_param("mem_alloc",mem_alloc,175000000)
  call from_param("sample_scale",sample_scale,4)
  call from_param("subsam_increment",subsam_increment,1.)
  call from_param("ignore_wrapping",ignore_wrapping,0)
  ! ALLOCATE INPUT DATA AND MASK
  allocate(d(nt,nx),mask_in(nt,nx),norm_d(nt,nx))

  ! READ INPUT DATA
  call sep_read(d)

  ! INVERT AND NORMALIZE THE DATA
  d=d*-1.
  maxdat=maxval(d)
  mindat=minval(d)
  rangedat=maxdat-mindat
  norm_d=(d/rangedat-mindat/rangedat)
  deallocate(d)

  ! READ IN INPUT MASK
  call sreed("mask_in", mask_in, 4*nt*nx) 
!!$write(0,*) mask_in
!!$stop
!!$  ! COUNT NONZERO VALUES IN MASK
!!$  non_zero_mask=0
!!$  do it=1,nt
!!$     do ix=1,nx
!!$        if (mask_in(it,ix)==1.) then
!!$           non_zero_mask=non_zero_mask+1
!!$        end if
!!$     end do
!!$  end do
!!$
!!$  ! MAKE A LOOK UP TABLE TO TRANSFORM DATA TO WEIGHT
!!$  allocate(look_up_tab(non_zero_mask,3))
!!$  ir=0
!!$
!!$  do ix=1,nx
!!$     !   row_count=0
!!$     do it=1,nt
!!$        if (mask_in(it,ix)==1.) then
!!$           ir=ir+1
!!$           !        row_count=row_count+1
!!$           look_up_tab(ir,1)=ir  ! wt row (or column as they are the same)
!!$           look_up_tab(ir,2)=it !row_count  ! data row
!!$           look_up_tab(ir,3)=ix  ! data column
!!$        end if
!!$     end do
!!$  end do


!!$  ! COUNT NONZERO VALUES IN MASK
  non_zero_mask=0

  do it=1,nt
     do ix=1,nx
        if (real(it)/subsam_increment-floor(real(it)/subsam_increment)<0.01.and.real(ix)/subsam_increment-floor(real(ix)/subsam_increment)<0.01.and.mask_in(it,ix)==1.) then
           non_zero_mask=non_zero_mask+1
        end if
     end do
  end do

  ! MAKE A LOOK UP TABLE TO TRANSFORM DATA TO WEIGHT
  allocate(look_up_tab(non_zero_mask,3))
  ir=0

  do ix=1,nx
     !   row_count=0
     do it=1,nt
        if  (real(it)/subsam_increment-floor(real(it)/subsam_increment)<0.01.and.real(ix)/subsam_increment-floor(real(ix)/subsam_increment)<0.01.and.mask_in(it,ix)==1.) then
           ir=ir+1
           !        row_count=row_count+1
           look_up_tab(ir,1)=ir  ! wt row (or column as they are the same)
           look_up_tab(ir,2)=it !row_count  ! data row
           look_up_tab(ir,3)=ix  ! data column
        end if
     end do
  end do

  write(0,*) 'non_zero_mask',non_zero_mask







!!$  do it=1,ir
!!$     write(0,*) look_up_tab(it,1:)
!!$  end do



  ! ALLOCATE SPARSE MATRIX ...MAKE AS BIG AS ALLOWABLE
  allocate(sparse_mat(mem_alloc,3))! 175000000

  ! ALLOCATE NEW POINT TRACKER AND GRID
  box_size=dense_dist*2+1
  big_box_size=max_dist*2+1
  fill=max_dist-dense_dist
  pi_var=acos(-1.)
  n_new_val=big_box_size**2 !max number of weights for each node
  write(0,*) 'max number of random samples',sample_scale*nint(3.*pi_var*real(fill)) 
  allocate(val_list(n_new_val),box_grid(big_box_size,big_box_size),box_grid_row(big_box_size,big_box_size))
  allocate(box_grid_col(big_box_size,big_box_size),d_vec(non_zero_mask),d_vec_exp(non_zero_mask))
  allocate(box_grid_bnds(big_box_size,big_box_size),box_grid_1d((big_box_size)*(big_box_size)))


!!$  ! MAKE A SAMPLE TEMPLATE
!!$  smpl_cnt=0
!!$  allocate(sample_template(n_new_val,2))
!!$  call create_template(sample_template,smpl_cnt)
!!$  allocate(sample_template2(smpl_cnt,2))
!!$  sample_template2=sample_template(1:smpl_cnt,1:)
!!$  deallocate(sample_template)
!!$  allocate(sample_template(smpl_cnt,2))
!!$  sample_template=sample_template2
!!$  deallocate(sample_template2)
  write(0,*) 'sample_count',smpl_cnt
!!$do it=1,smpl_cnt
!!$ write(0,*) sample_template(it,1:)
!!$end do
!!$stop

  ! EXTRACT TOP AND BOTTOM OF MASK
  allocate(topbnd(nx),botbnd(nx))
  topbnd=1
  botbnd=nt
  do ix=1,nx
     do  it=2,nt
        if (mask_in(it,ix)==1..and.mask_in(it-1,ix)==0.) topbnd(ix)=it
        if (mask_in(it,ix)==0..and.mask_in(it-1,ix)==1.) botbnd(ix)=it-1
     end do
  end do

  ! LOOP OVER EACH ROW OF THE WEIGHT MATRIX
  sparse_mat_index=0 ! index of sparse matrix
  col_in_row=0       ! keep track of number of column in each row

  loop_over_rows:   do irow=1,non_zero_mask

     ! EACH ROW IN THE WEIGHT MATRIX CORRESPONDS TO A POINT IN THE INPUT IMAGE 
     ! HERE WE LOOK UP THE INDEXES OF THAT ROW
     row1=look_up_tab(irow,2)  !assign row
     col1=look_up_tab(irow,3); !assign col

     ! INITIALIZE GRID PARAMETERS
     box_grid=0.
     box_grid_row=0.
     box_grid_col=0.
     box_grid_bnds=0.

     ! INITIALIZE NEW POINT TRACKING PARAMETERS
     val_list=0. 
     val_cnt=0.

     ! AROUND EACH POINT IN THE IMAGE, CONTRUCT A GRID TO SAMPLE FROM row1,col1 to row2,col
     ! JUMP RANDOM SHIFTS WHEN ABOVE OR BELOW MASK BOUNDARY
     call  make_grid(nx,max_dist,row1,col1,row2,col2,topbnd,botbnd,box_grid,box_grid_row,box_grid_col,box_grid_bnds,norm_d,ignore_wrapping)
     !write(0,*) 'row min,max',minval(box_grid_row),maxval(box_grid_row)
     !write(0,*) 'col min,max',minval(box_grid_col),maxval(box_grid_col)
     ! AROUND EACH POINT IN THE IMAGE, CONTRUCT A GRID TO SAMPLE FROM row1,col1 to row2,col
     ! JUMP RANDOM SHIFTS WHEN ABOVE OR BELOW MASK BOUNDARY
     !     call  make_grid2(nx,nt,max_dist,row1,col1,row2,col2,topbnd,botbnd,box_grid,box_grid_row,box_grid_col,box_grid_bnds,norm_d)




     ! RESHAPE TO 1D TO PASS TO lint2
     do iq=1,big_box_size
        box_grid_1d(1+(iq-1)*big_box_size:big_box_size+(iq-1)*big_box_size)=box_grid(1:big_box_size,iq)
     end do

     ! LOOP OVER GRID CALCULATING WEIGHTS FOR EACH POINT
     !call calc_wt(nx,nt,mem_alloc,dense_dist,max_dist,amp_thresh,zero_tol,row1,col1,box_grid_1d,box_grid,box_grid_row,box_grid_col,box_grid_bnds,sparse_mat,sparse_mat_index,col_in_row,look_up_tab,val_list,val_cnt,norm_d)
!!$ allocate(tester(2,2))
!!$write(0,*) 'allocated tester',irow 

     ! call calc_wt_template(sample_template,nx,nt,mem_alloc,dense_dist,max_dist,amp_thresh,zero_tol,row1,col1,box_grid_1d,box_grid,box_grid_row,box_grid_col,box_grid_bnds,sparse_mat,sparse_mat_index,col_in_row,look_up_tab,val_list,val_cnt,norm_d,2)
     ! LOOP OVER GRID CALCULATING WEIGHTS FOR RANDOMLY SAMPLED POINTS
     call calc_wt_rand(nx,nt,mem_alloc,sample_scale,dense_dist,max_dist,amp_thresh,zero_tol,row1,col1,box_grid_1d,box_grid,box_grid_row,box_grid_col,box_grid_bnds,sparse_mat,sparse_mat_index,col_in_row,look_up_tab,val_list,val_cnt,norm_d)
!!$deallocate(tester)
!!$ allocate(tester(2,2))
!!$write(0,*) 'allocated tester',irow

     ! ADD 1'S ALONG DIAGONAL
     !   isnew2: if (IsNew(val_list,val_cnt,real(irow))) then
     !     val_cnt=val_cnt+1 
     !     val_list(val_cnt)=real(irow) ! if new point, add it to the list           
     sparse_mat_index=sparse_mat_index+1
     if (sparse_mat_index>=mem_alloc) then
        write(0,*) 'did not allocate enough memory'
        stop
     end if

     col_in_row=col_in_row+1 ! a column has been added to this row
     sparse_mat(sparse_mat_index,1)=irow
     sparse_mat(sparse_mat_index,2)=irow
     sparse_mat(sparse_mat_index,3)=1.
     !   end if isnew2
     col_in_row=0
     if (real(irow)/100.-floor(real(irow)/100.)<0.001) then
        write(0,*) 'finished row',irow,'of ',non_zero_mask
     end if
  end do loop_over_rows


  ! TRIM THE EXTRA OFF sparse_mat
  write(0,*) 'total_sparse before trim',sparse_mat_index
  total_sparse=sparse_mat_index
  write(0,*) 'here1a',total_sparse
  write(0,*) 'total_sparse after trim',total_sparse
  !  deallocate(sparse_mat2)
  allocate(sparse_mat2(total_sparse,3))
  !  allocate(sparse_mat2(2,2))
  allocate(tester(2,2))
  write(0,*) 'here1'
  sparse_mat2=sparse_mat(1:total_sparse,1:3)
  write(0,*) 'here2'
  deallocate(sparse_mat)
  write(0,*) 'here3'
  allocate(sparse_mat(total_sparse,3))
  write(0,*) 'here4'
  sparse_mat=sparse_mat2
  write(0,*) 'here5'
  deallocate(sparse_mat2)
  write(0,*) 'here6'
!!$  do it=1,total_sparse
!!$     write(0,*) sparse_mat(it,1:)
!!$  enddo

  ! SORT THE SPARSE MATRIX
  write(0,*) 'sorting'
  allocate(sparse_mat_sort(3,total_sparse))
  do it=1,3
     sparse_mat_sort(it,1:)=sparse_mat(1:,it)
  end do
  call quick_sort(sparse_mat_sort,1,3,total_sparse)
  !write(0,*) 'max/min', maxval(sparse_mat_sort(2,1:)), minval(sparse_mat_sort(2,1:))
  !write(0,*) 'max/min', maxval(sparse_mat_sort(1,1:)), minval(sparse_mat_sort(1,1:))
  !write(0,*) 'max/min', maxval(sparse_mat_sort(3,1:)), minval(sparse_mat_sort(3,1:))

  last_index=1
  do it=2,total_sparse
     if (sparse_mat_sort(1,it)/=sparse_mat_sort(1,it-1)) then
        call quick_sort(sparse_mat_sort(1:,last_index:it-1),2,3,it-last_index)
        last_index=it
     end if
  end do
  do it=1,3
     sparse_mat(1:,it)=sparse_mat_sort(it,1:)
  end do
  deallocate(sparse_mat_sort)
  write(0,*) 'sorted'
!!$  do it=1,total_sparse
!!$     write(0,*) sparse_mat(it,1:)
!!$  enddo

  ! REMOVE REPEATING VALUES
  allocate(sparse_mat2(total_sparse,3))
  index_new=1
  sparse_mat2=0.
  sparse_mat2(1,1:)=sparse_mat(1,1:)
  do sparse_index=2,total_sparse
     if (sparse_mat(sparse_index,1)/=sparse_mat(sparse_index-1,1).or.sparse_mat(sparse_index,2)/=sparse_mat(sparse_index-1,2)) then
        index_new=index_new+1
        sparse_mat2(index_new,1:)=sparse_mat(sparse_index,1:)
     end if
  end do
  write(0,*) 'removed repeaters'
  deallocate(sparse_mat)
  write(0,*) 'total_sparse_before repeater removal', total_sparse
  total_sparse=index_new
  write(0,*) 'total_sparse_after repeater removal', total_sparse
  allocate(sparse_mat(total_sparse,3))
  sparse_mat=sparse_mat2(1:total_sparse,1:)
  deallocate(sparse_mat2)
!!$
!!$  call to_history("n1",total_sparse,"test"); call to_history("n2",3,"test") 
!!$  call to_history("n3",1.,"test")
!!$  call to_history("d1",1.,"test"); call to_history("d2",1,"test")
!!$  call to_history("d3",1.,"test")
!!$  call to_history("o1",0.,"test"); call to_history("o2",0.,"test")
!!$  call to_history("o3",0.,"test")
!!$  call to_history("esize",4,"test")
!!$  call sep_write(sparse_mat,"test")




!!$
!!$  do it=1,total_sparse
!!$     write(0,*) sparse_mat(it,1:)
!!$  enddo

  ! MAKE SYMMETRIC
  write(0,*) 'make symmetric'
  index_new=0
  newsize=2*total_sparse-maxval(sparse_mat(1:,1))
  write(0,*) 'newsize',newsize
  allocate(sparse_mat2(newsize,3))
  do it=1,total_sparse
     if (sparse_mat(it,1)==sparse_mat(it,2)) then
        index_new=index_new+1
        sparse_mat2(index_new,1:)=sparse_mat(it,1:)
     else
        index_new=index_new+1
        sparse_mat2(index_new,1:)=sparse_mat(it,1:)
        index_new=index_new+1
        sparse_mat2(index_new,1)=sparse_mat(it,2)
        sparse_mat2(index_new,2)=sparse_mat(it,1)
        sparse_mat2(index_new,3)=sparse_mat(it,3)
     end if
  end do
  deallocate(sparse_mat)
  total_sparse=index_new  !newsize
  allocate(sparse_mat(total_sparse,3))
  sparse_mat=sparse_mat2
  deallocate(sparse_mat2)
!!$  do it=1,total_sparse
!!$     write(0,*) sparse_mat(it,1:)
!!$  enddo

  ! RE-SORT THE NOW SYMMETRIC SPARSE MATRIX
  allocate(sparse_mat_sort(3,total_sparse))
  do it=1,3
     sparse_mat_sort(it,1:)=sparse_mat(1:,it)
  end do
  call quick_sort(sparse_mat_sort,1,3,total_sparse)
  write(0,*) 'resorting'
  last_index=1
  do it=2,total_sparse
     if (sparse_mat_sort(1,it)/=sparse_mat_sort(1,it-1)) then
        call quick_sort(sparse_mat_sort(1:,last_index:it-1),2,3,it-last_index)
        last_index=it
     end if
  end do
  do it=1,3
     sparse_mat(1:,it)=sparse_mat_sort(it,1:)
  end do
  deallocate(sparse_mat_sort)

!!$  do it=1,total_sparse
!!$     write(0,*) sparse_mat(it,1:)
!!$  enddo

  ! COMPUTE d_vec and d_vec_exp
  write(0,*) 'computing D and D^-.5' 
  last_index=1
  do it=2,total_sparse
     if (sparse_mat(it,1)/=sparse_mat(it-1,1)) then
        d_vec(nint(sparse_mat(it-1,1)))=sum(sparse_mat(last_index:it-1,3))
        d_vec_exp(nint(sparse_mat(it-1,1)))=d_vec(nint(sparse_mat(it-1,1)))**-.5
        last_index=it
     end if
  end do
  d_vec(nint(sparse_mat(total_sparse,1)))=sum(sparse_mat(last_index:total_sparse,3))
  d_vec_exp(nint(sparse_mat(total_sparse,1)))=d_vec(nint(sparse_mat(total_sparse,1)))**-.5
  !  write(0,*) d_vec
  !write(0,*) 'd_vec_exp',d_vec_exp

  ! COMPUTE D-W
  write(0,*) 'D-W'
  allocate(DminusW(total_sparse,3))
  DminusW(1:,1:2)=sparse_mat(1:,1:2)
  DminusW(1:,3)=-1*sparse_mat(1:,3)
  do sparse_index=1,total_sparse
     if (sparse_mat(sparse_index,1)==sparse_mat(sparse_index,2))then
        DminusW(sparse_index,1:2)=sparse_mat(sparse_index,1:2)
        DminusW(sparse_index,3)=d_vec(nint(sparse_mat(sparse_index,2)))-sparse_mat(sparse_index,3)
     end if
  end do

!!$ do it=1,total_sparse
!!$     write(0,*) DminusW(it,1:)
!!$ enddo 

  ! COMPUTE (D-W)*D^.5
  allocate(DminusWD(total_sparse,3))
  do sparse_index=1,total_sparse
     DminusWD(sparse_index,1:2)=DminusW(sparse_index,1:2)
     DminusWD(sparse_index,3)=DminusW(sparse_index,3)*d_vec_exp(nint(DminusWD(sparse_index,2)))
  end do
  deallocate(DminusW)

  ! COMPUTE D^.5*(D-W)*D^.5
  write(0,*) 'D^-.5(D-W)D^-.5'
  allocate(DDminusWD(total_sparse,3))
  do sparse_index=1,total_sparse
     DDminusWD(sparse_index,1:2)=DminusWD(sparse_index,1:2)
     DDminusWD(sparse_index,3)=DminusWD(sparse_index,3)*&
     d_vec_exp(nint(DminusWD(sparse_index,1)))
  end do
  deallocate(DminusWD)
!!$
!!$  write(0,*) 'DDminusWD'
!!$  do it=1,total_sparse
!!$     write(0,*) DDminusWD(it,1:)
!!$  enddo
!!$


  ! RITE OUT THE SPARSE MATRIX
  call srite("out",DDminusWD,4*total_sparse*3)
  call to_history( "n1", total_sparse);call to_history( "n2", 3 );  call to_history( "n3", 1 )
  call to_history( "d1", 1.);          call to_history( "d2", 1.);  call to_history( "d3", 1.)
  call to_history( "o1", 0.);          call to_history( "o2", 0.);  call to_history( "o3", 0.)
  call to_history("esize",4);
  ! RITE TO THE HISTORY FILE THE SIZE OF THE IMAGE WITHIN THE MASK AND OTHER PARAMETERS
  call to_history("nt",nt); call to_history("nx",nx); call to_history("ny",ny)
  call to_history("non_zero_mask",non_zero_mask);
  call to_history("ncv_val",ncv_val);
  deallocate(DDminusWD)

  call to_history("n1",non_zero_mask,"look_up"); call to_history("n2",3,"look_up") 
  call to_history("n3",1.,"look_up")
  call to_history("d1",1.,"look_up"); call to_history("d2",1,"look_up")
  call to_history("d3",1.,"look_up")
  call to_history("o1",0.,"look_up"); call to_history("o2",0.,"look_up")
  call to_history("o3",0.,"look_up")
  call to_history("esize",4,"look_up")
  call sep_write(look_up_tab,"look_up")
  deallocate(look_up_tab)

  call to_history("n1",non_zero_mask,"d_vec_exp"); call to_history("n2",1,"d_vec_exp") 
  call to_history("n3",1.,"d_vec_exp")
  call to_history("d1",1.,"d_vec_exp"); call to_history("d2",1,"d_vec_exp")
  call to_history("d3",1.,"d_vec_exp")
  call to_history("o1",0.,"d_vec_exp"); call to_history("o2",0.,"d_vec_exp")
  call to_history("o3",0.,"d_vec_exp")
  call to_history("esize",4,"d_vec_exp")
  call sep_write(d_vec_exp,"d_vec_exp")
  deallocate(d_vec_exp)

end program Sparse_weight_random

